#!/usr/local/bin/perl
#########################################################
#                                                       #
#                      ForwardPro                       #
#                                                       #
#########################################################
#                                                       #
#                      script.pl                        #
#                                                       #
#   Configure this script by filling in the variables   #
#   below. After that put all three scripts into your   #
#   CGI-BIN and CHMOD them 755. Put the datafile into   #
#   into a non-web accessable directory (if you don't   #
#   have access to one a web accessable directory will  #
#   work but is much less secure) and CHMOD it 777.     #
#                                                       #
#   If you have any further questions, direct them to   #
#   the support forum at http://www.go2cgi.com/         #
#                                                       #
#########################################################
#                                                       #
#         Copyright  1999 W. Dustin Alligood           #
#                                                       #
#########################################################

# The path to the file you want displayed at the top
# of all the CGI generated pages (sign-up/modify)
$header='/usr/home/go2/public_html/forward/header.txt';

# The path to the datafile
$datafile='/usr/home/go2/non-web/data.txt';

# Your domain name less the http://www.
$domain='go2.com.py';

# Allow users to put the ad on their page (yes/no)
$placeban='yes';

# Width of username box (adjust until it fills the line)
$width='15';

# Your redirection service's title
$title='Go2! Forwarding Service';

# The URL to this script
$script='script.pl';

# The URL the user should be taken to after they have
# modified their account
$leave='http://www.go2.com.py/home.shtml';

# What is the page the URL above points to?
$whatis='home page';

# If you have $placeban set to yes, insert the HTML that
# the users must put on their pages here
$html='<a href="http://www.yourdomain.com/" target="_top"><img src="http://www.yourdomain.com/banner.gif" width=468 height=60 border=0><br>Get your own redirecting URL!</a>';


# Change nothing below this line
#########################################################


$html =~ s/\&/\&amp\;/g;
$html =~ s/"/\&quot\;/g;
$html =~ s/</\&lt\;/g;
$html =~ s/>/\&gt\;/g;

if ($ENV{'QUERY_STRING'} =~ /do=step2/)
{
	&steptwo;
}
elsif ($ENV{'QUERY_STRING'} =~ /do=leave/)
{
	print "Location: $leave\n\n";
}
elsif ($ENV{'QUERY_STRING'} =~ /do=modify/)
{
	&stepthree;
}
elsif ($ENV{'QUERY_STRING'} =~ /do=step4/)
{
	&stepfour;
}
elsif ($ENV{'QUERY_STRING'} =~ /do=step5/)
{
	&stepfive;
}
elsif ($ENV{'QUERY_STRING'} =~ /do=step1/)
{
	&stepone;
}
else{
	&into;
}


sub into
{
	print "Content-type: text/html\n\n";
	print "<html><head><title>$title</title></head><body>\n";
	open(HEAD,"<$header");
	@top=<HEAD>;
	close(HEAD);
	print "@top\n";
	print "<form action=\"$script\" method=\"get\">\n";
	print "<P><CENTER>\n";
	print "<table border=1 cellpadding=1 cellspacing=0 bgcolor=white><tr><td bgcolor=blue>\n";
	print "<font face=arial color=white>$title</font>\n";
	print "</td></tr><tr><td>\n";
	print "<TABLE PADDING=5>\n";
	print "<TR><TD>\n";
	print "<table board=0><tr><td width=75>\n";
	print "<input type=hidden value=\"step1\" name=\"do\">\n";
	print "<p><center><input type=Submit value=\"Sign-up\"></center></p>\n";
	print "</td><td width=200>Sign-up for a new forwarding URL account</td></tr><tr><td></form><form action=\"$script\" method=\"get\">\n";
	print "<input type=hidden value=\"modify\" name=\"do\">\n";
	print "<p><center><input type=Submit value=\"Modify\"></center></p>\n";
	print "</td><td width=200>Modify your existing forwarding URL account</td></tr><tr><td></form><form action=\"$script\" method=\"get\">\n";
	print "<input type=hidden value=\"leave\" name=\"do\">\n";
	print "<p><center><input type=Submit value=\"Exit\"></center></p>\n";
	print "</td><td width=200>Leave our forwarding service and return to our $whatis</td></tr></table>\n";
	print "</td></tr></table>\n";
	print "</td></tr></table>\n";
	print "</form></body></html>\n";
}
sub stepfive
{

 	@fval=split(/&/,$ENV{'QUERY_STRING'});
	foreach $i (0 .. $#fval){
		($name,$val)=split (/=/,$fval[$i],2);
		$val=~tr/+/ /;
		$val=~ s/%(..)/pack("c",hex($1))/ge;
		$name=~tr/+/ /;
		$name=~ s/%(..)/pack("c",hex($1))/ge;
		$fild{$name}=$val;
	}


	$message = "" ;
	$found_err = "" ;

	$errmsg = "<p>You didn't tell us what your URL is. Please do so.</p>\n" ;

	if ($fild{'url'} eq "http://") {
		$message = $message.$errmsg ;
		$found_err = 1 ;
	}
	if ($fild{'url'} eq "") {
		$message = $message.$errmsg ;
		$found_err = 1 ;
	}

	$errmsg = "<p>You need a valid email address. Please enter one.</p>\n" ;

	if ($fild{'email'} !~ /.+\@.+\..+/) {
		$message = $message.$errmsg ;
		$found_err = 1 ; 
	}

	$errmsg = "<p>You didn't enter your name. Please tell us what it is.</p>\n" ;

	if ($fild{'name'} eq "") {
		$message = $message.$errmsg ;
		$found_err = 1 ;
	}

	$errmsg = "<p>You must enter a password, you'll need it to edit your account.</p>\n" ;

	if ($fild{'password'} eq "") {
		$message = $message.$errmsg ;
		$found_err = 1 ;
	}

	if ($found_err) {
		&PrintError;
	} else {

	print "Content-type: text/html\n\n";
	print "<html><head><title>$title</title></head><body>\n";
	open(HEAD,"<$header");
	@top=<HEAD>;
	close(HEAD);
	print "@top\n";
	print "<form action=\"$script\" method=\"get\">\n";
	print "<input type=hidden value=\"leave\" name=\"do\">\n";
	print "<P><CENTER>\n";
	print "<table border=1 cellpadding=1 cellspacing=0 bgcolor=white><tr><td bgcolor=blue>\n";
	print "<font face=arial color=white>Modify - Step 3 of 3</font>\n";
	print "</td></tr><tr><td>\n";
	print "<TABLE PADDING=5>\n";
	print "<TR><TD>\n";

	open(DATA,"<$datafile");
		@subs=<DATA>;
	close(DATA);
	$i=-1;
	foreach $sub(@subs){
		$i=$i+1;
		@subdata = split(/\|/,$sub);
		if(@subdata[0] eq $fild{'username'}){
			@subs[$i]="$fild{'username'}|$fild{'url'}|$fild{'password'}|$fild{'ad'}|$fild{'email'}|$fild{'name'}|$fild{'wtitle'}|$fild{'desc'}|$fild{'keywords'}\n";
		}	
	}
	$ii=-1;
	open(DATA,">$datafile");
	while($ii<=$i+1){
		$ii=$ii+1;
		$temp="@subs[$ii]";
		print DATA "$temp";
	}
	close(DATA);

	print "<blockquote><center>&nbsp;<br>Your account has been updated<br>\n";

	if($fild{'ad'} eq 'onpage'){
		print "</center></blockquote><p>Since you wanted to put the ad on your page you'll need to copy this code on to it.</p>\n";
		print "<blockquote><p><tt>$html</tt></p></blockquote><center><blockquote>\n";
	}

	print "<br><input type=Submit value=\"Okay\"></center></blockquote>\n";

	print "</td></tr></table>\n";
	print "</td></tr></table>\n";
	print "</form></body></html>\n";
	}

}
sub stepfour
{
 	@fval=split(/&/,$ENV{'QUERY_STRING'});
	foreach $i (0 .. $#fval){
		($name,$val)=split (/=/,$fval[$i],2);
		$val=~tr/+/ /;
		$val=~ s/%(..)/pack("c",hex($1))/ge;
		$name=~tr/+/ /;
		$name=~ s/%(..)/pack("c",hex($1))/ge;
		$fild{$name}=$val;
	}


	$message = "" ;
	$found_err = "" ;

	$errmsg = "<p>Wrong username/password combination. Try again.</p>\n" ;

	$errtype='Modify';
	$errscript="modify";

	if ($fild{'username'} eq "") {
		$message = $message.$errmsg ;
		$found_err = 1 ;
	}
	if ($fild{'password'} eq "") {
		$message = $message.$errmsg ;
		$found_err = 1 ;
	}
	open(DATA,"<$datafile");
		@subs=<DATA>;
	close(DATA);

	$found_err = 1 ;
	foreach $sub(@subs){
		@subdata = split(/\|/,$sub);
		if(@subdata[0] eq $fild{'username'}){
			if(@subdata[2] ne $fild{'password'}){
				$message = $message.$errmsg ;
			}else{
				$un=@subdata[0];
				$url=@subdata[1];
				$pass=@subdata[2];
				$ad=@subdata[3];
				$em=@subdata[4];
				$nm=@subdata[5];
				$tl=@subdata[6];
				$de=@subdata[7];
				$ke=@subdata[8];				
				$found_err = 0;
			}
		}	
	}

	if ($found_err) {
		&PrintError;
	} else {

	print "Content-type: text/html\n\n";
	print "<html><head><title>$title</title></head><body>\n";
	open(HEAD,"<$header");
	@top=<HEAD>;
	close(HEAD);
	print "@top\n";
	print "<form action=\"$script\" method=\"get\">\n";
	print "<input type=hidden value=\"step5\" name=\"do\">\n";
	print "<P><CENTER>\n";
	print "<table border=1 cellpadding=1 cellspacing=0 bgcolor=white><tr><td bgcolor=blue>\n";
	print "<font face=arial color=white>Modify - Step 2 of 3</font>\n";
	print "</td></tr><tr><td>\n";
	print "<TABLE PADDING=5>\n";
	print "<TR><TD>\n";
	print "<p>Here's what you signed-up with. You can edit anything you wish<br>except for your username. If you want to change it sign-up for a<br>new account.</p>\n";

	print "<P><TABLE BORDER=0>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "         <P>Username:\n";
	print "      </TD><TD>\n";
	print "         <P>http://$un.$domain/<input type=hidden value=\"$un\" name=\"username\">\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "         <P>Your Current URL:\n";
	print "      </TD><TD>\n";
	print "         <P><INPUT TYPE=\"text\" NAME=\"url\" VALUE=\"$url\" SIZE=30>\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "         <P>Your Email Address:\n";
	print "      </TD><TD>\n";
	print "         <P><INPUT TYPE=\"text\" NAME=\"email\" VALUE=\"$em\" SIZE=30>\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "         <P>Your Name:\n";
	print "      </TD><TD>\n";
	print "         <P><INPUT TYPE=\"text\" NAME=\"name\" VALUE=\"$nm\" SIZE=30>\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "         <P>Website Title:\n";
	print "      </TD><TD>\n";
	print "         <P><INPUT TYPE=\"text\" NAME=\"wtitle\" VALUE=\"$tl\" SIZE=30>\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "        <P>Website Description:\n";
	print "      </TD><TD>\n";
	print "         <P><INPUT TYPE=\"text\" NAME=\"desc\" VALUE=\"$de\" SIZE=30>\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "        <P>Website Keywords:\n";
	print "      </TD><TD>\n";
	print "         <P><INPUT TYPE=\"text\" NAME=\"keywords\" VALUE=\"$ke\" SIZE=30>\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "        <P>Your Desired Password:\n";
	print "      </TD><TD>\n";
	print "         <P><INPUT TYPE=\"text\" NAME=\"password\" VALUE=\"$pass\" SIZE=30>\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "        <P>Ad Preference:\n";
	print "      </TD><TD>\n";
	if($ad eq 'popup'){
		print "         <P><INPUT TYPE=\"radio\" NAME=\"ad\" VALUE=\"popup\" CHECKED>Ad in a popup\n";
	}else{
		print "         <P><INPUT TYPE=\"radio\" NAME=\"ad\" VALUE=\"popup\">Ad in a popup\n";
	}
	if($placeban eq "yes"){
		if($ad eq 'onpage'){
			print "         &nbsp;&nbsp;&nbsp;<INPUT TYPE=\"radio\" NAME=\"ad\" VALUE=\"onpage\" CHECKED>Ad on your page\n";
		}else{
			print "         &nbsp;&nbsp;&nbsp;<INPUT TYPE=\"radio\" NAME=\"ad\" VALUE=\"onpage\">Ad on your page\n";
		}
	}
	if($ad eq 'delay'){
		print "         <BR><INPUT TYPE=\"radio\" NAME=\"ad\" VALUE=\"delay\" CHECKED>Ad on delay page\n";
	}else{
		print "         <BR><INPUT TYPE=\"radio\" NAME=\"ad\" VALUE=\"delay\">Ad on delay page\n";
	}
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD COLSPAN=2 ALIGN=RIGHT>\n";
	print "         <INPUT TYPE=\"Submit\" VALUE=\"Next...\">\n";
	print "      </TD></TR>\n";
	print "</TABLE>\n";
	
	print "</td></tr></table>\n";
	print "</td></tr></table>\n";
	print "</form></body></html>\n";
	}
}
sub stepthree
{
	print "Content-type: text/html\n\n";
	print "<html><head><title>$title</title></head><body>\n";
	open(HEAD,"<$header");
	@top=<HEAD>;
	close(HEAD);
	print "@top\n";
	print "<form action=\"$script\" method=\"get\">\n";
	print "<input type=hidden value=\"step4\" name=\"do\">\n";
	print "<P><CENTER>\n";
	print "<table border=1 cellpadding=1 cellspacing=0 bgcolor=white><tr><td bgcolor=blue>\n";
	print "<font face=arial color=white>Modify - Step 1 of 3</font>\n";
	print "</td></tr><tr><td>\n";
	print "<TABLE PADDING=5>\n";
	print "<TR><TD>\n";
	
	print "<table border=0><tr><td>\n";
	print "Username:</td><td><input type=text size=30 name=username></td></tr><tr><td>\n";
	print "Password:</td><td><input type=password size=30 name=password>\n";
	print "</td></tr><tr><td colspan=2 align=\"right\"><p><input type=Submit value=\"Next...\"></p></td></tr></table>\n";
	
	print "</td></tr></table>\n";
	print "</td></tr></table>\n";
	print "</form></body></html>\n";
}

sub steptwo
{

 	@fval=split(/&/,$ENV{'QUERY_STRING'});
	foreach $i (0 .. $#fval){
		($name,$val)=split (/=/,$fval[$i],2);
		$val=~tr/+/ /;
		$val=~ s/%(..)/pack("c",hex($1))/ge;
		$name=~tr/+/ /;
		$name=~ s/%(..)/pack("c",hex($1))/ge;
		$fild{$name}=$val;
	}


	$message = "" ;
	$found_err = "" ;

	$errmsg = "<p>You have not chosen a username. Please pick one.</p>\n" ;

	if ($fild{'username'} eq "") {
		$message = $message.$errmsg ;
		$found_err = 1 ;
	}

	$errmsg = "<p>You didn't tell us what your URL is. Please do so.</p>\n" ;

	if ($fild{'url'} eq "http://") {
		$message = $message.$errmsg ;
		$found_err = 1 ;
	}
	if ($fild{'url'} eq "") {
		$message = $message.$errmsg ;
		$found_err = 1 ;
	}

	$errmsg = "<p>You need a valid email address. Please enter one.</p>\n" ;

	if ($fild{'email'} !~ /.+\@.+\..+/) {
		$message = $message.$errmsg ;
		$found_err = 1 ; 
	}

	$errmsg = "<p>You didn't enter your name. Please tell us what it is.</p>\n" ;

	if ($fild{'name'} eq "") {
		$message = $message.$errmsg ;
		$found_err = 1 ;
	}

	$errmsg = "<p>You must enter a password, you'll need it to edit your account.</p>\n" ;

	if ($fild{'password'} eq "") {
		$message = $message.$errmsg ;
		$found_err = 1 ;
	}

	$errmsg = "<p>Sorry, that username is taken. Pick another.</p>\n" ;

	open(DATA,"<$datafile");
		@subs=<DATA>;
	close(DATA);

	$usrnm=$fild{'username'};
	$usrnm=lc($usrnm);

	foreach $sub(@subs){
		@subdata = split(/\|/,$sub);
		$ousrn=@subdata[0];
		$ousrn=lc($ousrn);
		if($ousrn eq $usrnm){
			$message = $message.$errmsg ;
			$found_err = 1 ;
		}	
	}

	$errtype='Sign-up';
	$errscript="step1";

	if ($found_err) {
		&PrintError;
	} else {

	$usrnm=$fild{'username'};
	lc($usrnm);

	open(DATA,">>$datafile");
		print DATA "$usrnm|$fild{'url'}|$fild{'password'}|$fild{'ad'}|$fild{'email'}|$fild{'name'}|$fild{'wtitle'}|$fild{'desc'}|$fild{'keywords'}\n";
	close(DATA);

	print "Content-type: text/html\n\n";
	print "<html><head><title>$title</title></head><body>\n";
	open(HEAD,"<$header");
	@top=<HEAD>;
	close(HEAD);
	print "@top\n";

	print "<form action=\"$script\" method=\"get\">\n";
	print "<input type=hidden value=\"modify\" name=\"do\">\n";
	print "<P><CENTER>\n";
	print "<table border=1 cellpadding=1 cellspacing=0 bgcolor=white width=90%><tr><td bgcolor=blue>\n";
	print "<font face=arial color=white>Sign-up - Step 2 of 2</font>\n";
	print "</td></tr><tr><td>\n";
	print "<TABLE PADDING=5>\n";
	print "<TR><TD>\n";


	print "<p><center><b><tt><a href=\"http://$usrnm.$domain/\" target=\"_new\">http://$fild{'username'}.$domain/</a> created!</tt></b></center></p>\n";

	print "<p>Your Website should now be accessible from your new forwarding URL. If it isn't perhaps you misstyped your URL when signing-up. Don't worry, you can change your setup by clicking the button below.</p>\n";
	if($fild{'ad'} eq 'onpage'){
		print "<p>Since you wanted to put the ad on your page you'll need to copy this code on to it. If you've changed your mind, click the button below to change your setup.</p>\n";
		print "<blockquote><p><tt>$html</tt></p></blockquote>\n";
	}
	print "<p><center><input type=Submit value=\"Change your Setup\"></center></p>\n";

	print "</td></tr></table>\n";
	print "</td></tr></table>\n";
	print "</form></body></html>\n";
	}

}

sub stepone
{

	print "Content-type: text/html\n\n";
	print "<html><head><title>$title</title></head><body>\n";
	open(HEAD,"<$header");
	@top=<HEAD>;
	close(HEAD);
	print "@top\n";
	print "<form action=\"$script\" method=\"get\">\n";
	print "<input type=hidden value=\"step2\" name=\"do\">\n";
	print "<P><CENTER>\n";
	print "<table border=1 cellpadding=1 cellspacing=0 bgcolor=white><tr><td bgcolor=blue>\n";
	print "<font face=arial color=white>Sign-up - Step 1 of 2</font>\n";
	print "</td></tr><tr><td>\n";
	print "<TABLE PADDING=5>\n";
	print "<TR><TD>\n";
	
	print "<P><TABLE BORDER=0>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "         <P>Username:\n";
	print "      </TD><TD>\n";
	print "         <P>http://<INPUT TYPE=\"text\"\n";
	print "         NAME=\"username\" VALUE=\"\" SIZE=$width>.$domain/\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "         <P>Your Current URL:\n";
	print "      </TD><TD>\n";
	print "         <P><INPUT TYPE=\"text\" NAME=\"url\" VALUE=\"http://\" SIZE=30>\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "         <P>Your Email Address:\n";
	print "      </TD><TD>\n";
	print "         <P><INPUT TYPE=\"text\" NAME=\"email\" VALUE=\"\" SIZE=30>\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "         <P>Your Name:\n";
	print "      </TD><TD>\n";
	print "         <P><INPUT TYPE=\"text\" NAME=\"name\" VALUE=\"\" SIZE=30>\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "         <P>Website Title:\n";
	print "      </TD><TD>\n";
	print "         <P><INPUT TYPE=\"text\" NAME=\"wtitle\" VALUE=\"\" SIZE=30>\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "        <P>Your Desired Password:\n";
	print "      </TD><TD>\n";
	print "         <P><INPUT TYPE=\"text\" NAME=\"password\" VALUE=\"\" SIZE=30>\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "        <P>Website Description:\n";
	print "      </TD><TD>\n";
	print "         <P><INPUT TYPE=\"text\" NAME=\"desc\" VALUE=\"\" SIZE=30>\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "        <P>Website Keywords:\n";
	print "      </TD><TD>\n";
	print "         <P><INPUT TYPE=\"text\" NAME=\"keywords\" VALUE=\"\" SIZE=30>\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD>\n";
	print "        <P>Ad Preference:\n";
	print "      </TD><TD>\n";
	print "         <P><INPUT TYPE=\"radio\" NAME=\"ad\" VALUE=\"popup\" CHECKED>Ad in a popup\n";
	if($placeban eq "yes"){
		print "         &nbsp;&nbsp;&nbsp;<INPUT TYPE=\"radio\" NAME=\"ad\" VALUE=\"onpage\">Ad on your page\n";
	}
	print "         <BR><INPUT TYPE=\"radio\" NAME=\"ad\" VALUE=\"delay\">Ad on delay page\n";
	print "      </TD></TR>\n";
	print "   <TR>\n";
	print "      <TD COLSPAN=2 ALIGN=RIGHT>\n";
	print "         <INPUT TYPE=\"Submit\" VALUE=\"Next...\">\n";
	print "      </TD></TR>\n";
	print "</TABLE>\n";

	print "</td></tr></table>\n";
	print "</td></tr></table>\n";
	print "</form></body></html>\n";
}

sub PrintError { 

print "Content-type: text/html\n\n";
print "<html><head><title>$title</title></head><body>\n";

open(HEAD,"<$header");
@top=<HEAD>;
close(HEAD);
print "@top\n";

print "<form action=\"$script\" method=\"get\">\n";
print "<input type=hidden name=\"do\" value=\"$errscript\">\n";
print "<p><center><table border=1 cellpadding=1 cellspacing=0 bgcolor=white><tr><td bgcolor=blue>\n";
print "<font face=arial color=white>$errtype - Error</font>\n";
print "</td></tr><tr><td>\n";
print "<TABLE PADDING=5>\n";
print "<TR><TD>\n";

print $message ;

print "<p><center><input type=Submit value=\"<- Back\" onClick=history.go(-1)></center></p>\n";

print "</td></tr></table></td></tr></table></center></p>\n";

print "</form></body></html>\n";

exit 0 ;
return 1 ; 

}

sub GetFormInput {

	(*fval) = @_ if @_ ;

	local ($buf);
	if ($ENV{'REQUEST_METHOD'} eq 'POST') {
		read(STDIN,$buf,$ENV{'CONTENT_LENGTH'});
	}
	else {
		$buf=$ENV{'QUERY_STRING'};
	}
	if ($buf eq "") {
			return 0 ;
		}
	else {
 		@fval=split(/&/,$buf);
		foreach $i (0 .. $#fval){
			($name,$val)=split (/=/,$fval[$i],2);
			$val=~tr/+/ /;
			$val=~ s/%(..)/pack("c",hex($1))/ge;
			$name=~tr/+/ /;
			$name=~ s/%(..)/pack("c",hex($1))/ge;

			if (!defined($field{$name})) {
				$field{$name}=$val;
			}

		   }
		}
return 1;
}